<template>
  <div :class="['ob-date-picker', isValid ? '' : 'ob-date-picker--error']" v-click-outside="hide" ref="reference">
    <div class="ob-date-picker__left">
      <date-time-input
        :value="value"
        :label="label"
        :isValid="true"
        :isTime="true"
        icon=""
        :blockDaysBeforeToday="true"
        errorMessage=""
        :dataQa="dataQa"
        @input="emitEvent"
      />
    </div>
    <div class="ob-date-picker__right">
      <div class="ob-date-picker__icon">
        <i :class="['icon', icon]" @click="isOpen = !isOpen"></i>
        <ObTooltip
          class="ob-date-picker__error"
          v-if="!isValid"
          :content="errorMessage"
          type="error"
          position="top-end"          
        >
          <i class="icon alert" />
        </ObTooltip>
      </div>
    </div>

    <select-dropdown
      ref="popper"
      v-model="isOpen"
      data-attr="ob-date-picker"
      :position="position"
      :width-inherit="false"
      :data-qa="dataQa"
    >
      <div
        v-if="this.$slots.default && this.$slots.default.length"
        class="ob-date-picker__header"
      >
        <slot />
      </div>
      <div class="ob-date-picker__container">
        <div class="ob-date-picker__calendar">
          <Datepicker
            ref="date"
            v-model="calendarValue"
            data-attr="ob-date-picker__container"
            :monday-first="true"
            :disabled-dates="disabledDates"
            :calendar-button="true"
            :inline="true"
            :full-month-name="true"
            :language="language"
            input-class="customize-input"
            :data-qa="dataQa"
            calendar-button-icon="icon calendar"
            @selected="selectedHandler"
          />
        </div>
        <div class="ob-date-picker__time" v-if="isTime">
          <div class="ob-date-picker__time-label">
            Дата и время
          </div>
          <div class="ob-date-picker__time-select">
            <div class="date-time-input">
              <date-time-input
                v-model="innerDate"
                label="Дата"
                :isValid="true"
                icon=""
                :blockDaysBeforeToday="true"
                errorMessage=""
                :dataQa="dataQa"
                @input="updateCalendar"
              />
            </div>
            <ob-select
              ref="timeSelect"
              v-model="time"
              :items="timeItems"
              label="Время"
              placeholder="Выберите время"
              :data-qa="dataQa"
            />
            <ob-button
              label="Выбрать"
              type="outline"
              placeholder="Выберите время"
              :data-qa="dataQa"
              @click="onSubmit"
            />
          </div>
        </div>
      </div>
    </select-dropdown>
  </div>
</template>

<script>
import moment from 'moment';
import ObSelect from 'common-components/src/obComponents/obSelect';
import SelectDropdown from 'common-components/src/obComponents/obSelect/select-dropdown';
import Datepicker from 'vuejs-datepicker';
import { ru, en, zh } from 'vuejs-datepicker/dist/locale';
import ObTooltip from 'common-components/src/obComponents/obTooltip';
import ObButton from 'common-components/src/obComponents/obButton';
import DateTimeInput from './dateTimeInput';
import ClickOutside from 'vue-click-outside'
export default {
  name: "orderDatePicker",

  components: {
    ObSelect,
    SelectDropdown,
    Datepicker,
    ObTooltip,
    ObButton,
    DateTimeInput,
  },

  props: {
    value: {
      type: [Number, String, Date],
      required: true
    },

    isTime: {
      type: Boolean,
      default: false
    },

    label: {
      type: String,
      default: "Label"
    },

    lang: {
      type: String,
      default: 'ru'
    },

    icon: {
      type: String,
      default: "calendar"
    },

    routeType: {
      type: [String, Number]
    },

    position: {
      type: String,
      default: 'bottom-start'
    },

    blockDaysBeforeToday: {
      type: Boolean,
      default: false
    },

    sinceTo: {
      type: Array,
      default: () => []
    },

    blockTimeDateBefore: {
      type: [String, Date, Number],
    },

    isValid: {
      type: Boolean,
      default: true
    },

    errorMessage: {
      type: String
    },

    dataQa: {
      type: String
    },

    allowWeekends: {
      type: Boolean,
      default: false
    }
  },

  mounted() {
    this.setBackup(this.value);

    this.$refs.date.$el.querySelectorAll('.prev').forEach(item => { item.innerHTML = '<i class="icon chevron-left"/>' });
    this.$refs.date.$el.querySelectorAll('.next').forEach(item => { item.innerHTML = '<i class="icon chevron-right"/>' });
  },

  provide () {
    return {
      select: this
    }
  },

  data() {
    return {
      isOpen: false,
      calendarValue: '',
      langOfCalendar: { ru, en, zh },
      time: '',
      innerDate: '',
      backup: '',
    };
  },

  computed: {
    timeItems() {
      let startPoint = 0;
      if (this.isCurrentDay && !this.isCalendarCurrentDay) {
        startPoint = 0;
      } else if (this.isCurrentDay || this.isCalendarCurrentDay) {
        const curMinutes = (new Date()).getMinutes();
        const curHour = curMinutes > 0 ? (new Date()).getHours() + 1 : (new Date()).getHours();
        startPoint = (curHour * 2) + 5
      }

      if (this.blockTimeDateBefore && this.value !== undefined) {
        const valueDate = new Date(this.blockTimeDateBefore).getDate()
        const valueMonth = new Date(this.blockTimeDateBefore).getMonth()
        const calDate = this.calendarValue ? new Date(this.calendarValue).getDate() : this.value.getDate()
        const calMonth = this.calendarValue ? new Date(this.calendarValue).getMonth() : this.value.getMonth()
        if ((calDate === valueDate) && (calMonth === valueMonth)) {
          const h = new Date(this.blockTimeDateBefore).getHours()
          const m = new Date(this.blockTimeDateBefore).getMinutes()
          const blockTime = moment(this.roundTime(moment(this.blockTimeDateBefore).set({ 'hour': h, 'minute': m }), moment.duration(30, 'minutes')))
          startPoint = ((new Date(blockTime)).getHours() * 2);
        }
      }
      return this.setTimeItems(startPoint);
    },

    isCurrentDay() {
      const curMonth = (new Date()).getMonth() + 1;
      const curDay = (new Date()).getDate();
      const valueMonth = new Date(this.value).getMonth() + 1;
      const valueDay = new Date(this.value).getDate();
      return (curMonth === valueMonth && curDay === valueDay);
    },

    isCalendarCurrentDay() {
      const curMonth = (new Date()).getMonth() + 1;
      const curDay = (new Date()).getDate();
      const valueMonth = new Date(this.calendarValue).getMonth() + 1;
      const valueDay = new Date(this.calendarValue).getDate();
      return (curMonth === valueMonth && curDay === valueDay);
    },

    disabledDates () {
      const holidaysRange = this.allowHolidays ? [] : [

      ]
      let weekendRange = this.allowWeekends ? [] : [6, 0]
      const datesRange = []
      const rangesOptions = {
        default: {
          days: weekendRange,
          ranges: holidaysRange,
          dates: datesRange
        },
        allowHolidays: {
          days: weekendRange,
          ranges: holidaysRange,
          dates: datesRange
        },
        allowWeekends: {
          days: weekendRange,
          ranges: holidaysRange,
          dates: datesRange
        },
        allowAll: {}
      }
      if (this.sinceTo) {
        this.sinceTo.forEach(it => {
          holidaysRange.push({
            from: new Date(it.from),
            to: new Date(new Date(it.to).setHours(0, 0, 0, 0))
          })
        })
      }

      if (this.blockAll) {
        holidaysRange.push({ from: new Date(), to: new Date(2050, 0, 0) })
        rangesOptions.allowAll.ranges = holidaysRange
      }

      if (this.blockDaysBeforeToday) {
        const h = 24 - new Date().getHours()
        holidaysRange.push({ from: new Date(1976, 0, 0), to: h > 3 ? new Date().setHours(0, 0, 0, 0) : new Date().setHours(12, 0, 0, 0) })
        rangesOptions.allowAll.ranges = holidaysRange
      }

      if (this.allowWeekends && this.allowHolidays) {
        weekendRange.length = 0
      }

      return this.allowHolidays ? rangesOptions.allowHolidays : this.allowWeekends ? rangesOptions.allowWeekends : this.allowAll ? rangesOptions.allowAll : rangesOptions.default
    },

    language() {
      return this.langOfCalendar[this.lang]
    },
  },

  watch: {
    value: {
      handler(newVal) {
        this.setBackup(newVal);
        this.calendarValue = newVal;
        this.innerDate = newVal;

        if (this.isTime) {
          let hour = newVal ? new Date(newVal).getHours() + "" : "";
          let minutes = newVal ? new Date(newVal).getMinutes() + "" : "";

          const curMinutes = (new Date()).getMinutes();
          const curHour = (new Date()).getHours();

          if (this.isCurrentDay && (+curHour + 3) > hour) {
            hour = (+curHour + 3 + '').padStart(2, 0);
            minutes = (curMinutes + '').padStart(2, 0);
          } else {
            hour = hour.padStart(2, 0);
            minutes = minutes.padStart(2, 0);
          }

          this.$nextTick(() => {
            this.time = this.timeItems.find(item => item.title === `${hour}:${minutes}`)?.title || `${minutes < '30' ? hour : +hour + 1 + ''}:${minutes < '30' ? '30' : '00'}`;
          })
        }
      },
      deep: true,
      immediate: true
    },
  },

  methods: {
    roundTime (date, duration) {
      return (Math.ceil((+date) / (+duration)) * (+duration))
    },

    emitEvent(e) {
      this.$emit('input', e);
    },

    setBackup(val) {
      this.backup = val;
    },

    updateCalendar($event) {
      let timestamp = '';
      const temp = new Date($event);

      const year = temp.getFullYear() + '';
      const month = temp.getMonth() + 1 + '';
      const day = temp.getDate() + '';

      timestamp = Date.parse(`${year.padStart(4, 0)}-${month.padStart(2, 0)}-${day.padStart(2, 0)}`)

      if (this.isTime) {
        let hour = new Date(this.calendarValue).getHours() + "";
        let minutes = new Date(this.calendarValue).getMinutes() + "";
        timestamp = Date.parse(`${year.padStart(4, 0)}-${month.padStart(2, 0)}-${day.padStart(2, 0)}T${hour.padStart(2, 0)}:${minutes.padStart(2, 0)}`)
      }
      this.calendarValue = timestamp;
      this.selectedHandler();
    },

    onSubmit() {
      let timestamp = '';

      const temp = new Date(this.innerDate);

      const year = temp.getFullYear() + '';
      const month = temp.getMonth() + 1 + '';
      const day = temp.getDate() + '';

      timestamp = Date.parse(`${year.padStart(4, 0)}-${month.padStart(2, 0)}-${day.padStart(2, 0)}`)

      if (this.isTime) {
        timestamp = Date.parse(`${year.padStart(4, 0)}-${month.padStart(2, 0)}-${day.padStart(2, 0)}T${this.time}`)
      }

      this.$emit('input', timestamp);
      this.isOpen = false;
    },

    hide($event) {
      let target = $event.target
      let popper = this.$refs.popper.$el
      let select = this.$refs.timeSelect ? this.$refs.timeSelect.$el : undefined
      if (target === popper || target === select || popper.contains(target) || target.classList.value.indexOf('ob-selector') > -1) {
        return false
      } else {
        this.reset();
        this.$emit('close', this.routeType)
        this.isOpen = false
      }
    },

    reset() {
      const day = this.backup ? new Date(this.backup).getDate() + "" : "";
      const month = this.backup ? new Date(this.backup).getMonth() + 1 + "" : "";
      this.day = day.padStart(2, 0);
      this.month = month.padStart(2, 0);
      this.year = `${this.backup ? new Date(this.backup).getFullYear() : ""}`;
      this.calendarValue = this.backup;  
      this.innerDate = this.backup;
      if (this.isTime) {
        const hour = this.backup ? new Date(this.backup).getHours() + "" : "";
        const minutes = this.backup ? new Date(this.backup).getMinutes() + "" : "";

        this.hour = hour.padStart(2, 0);
        this.minutes = minutes.padStart(2, 0);

        this.$nextTick(() => {
          this.time = this.timeItems.find(item => item.title === `${this.hour}:${this.minutes}`)?.title || `${this.minutes < '30' ? this.hour : +this.hour + 1 + ''}:${this.minutes < '30' ? '30' : '00'}`;
        })
      }
    },

    setTimeItems(startPoint) {
      const items = [];
      for (let i = startPoint; i < 48; i++) {
        items.push(this.getTimeItem(i))
      }
      return items;
    },

    getTimeItem (ind) {
      if (ind % 2 === 0) {
        return {
          uuid: ind < 20 ? `0${ind / 2}:00` : `${ind / 2}:00`,
          title: ind < 20 ? `0${ind / 2}:00` : `${ind / 2}:00`
        }
      } else {
        return {
          uuid: ind < 20 ? `0${(ind / 2).toFixed(0) - 1}:30` : `${(ind / 2).toFixed(0) - 1}:30`,
          title: ind < 20 ? `0${(ind / 2).toFixed(0) - 1}:30` : `${(ind / 2).toFixed(0) - 1}:30`
        }
      }
    },

    selectedHandler() {
      this.$nextTick(() => {
        const day = new Date(this.calendarValue).getDate() + "";
        const month = new Date(this.calendarValue).getMonth() + 1 + "";
        const year = new Date(this.calendarValue).getFullYear() + "";

        this.innerDate = Date.parse(`${year.padStart(4, 0)}-${month}-${day}`);
        if (this.isTime) {
          let hour = new Date(this.calendarValue).getHours() + "";
          let minutes = new Date(this.calendarValue).getMinutes() + "";
          const curMinutes = (new Date()).getMinutes();
          const curHour = (new Date()).getHours();

          if (this.isCalendarCurrentDay && (+curHour + 3) > hour) {
            hour = (+curHour + 3 + '').padStart(2, 0);
            minutes = (curMinutes + '').padStart(2, 0);
          } else {
            hour = hour.padStart(2, 0);
            minutes = minutes.padStart(2, 0);
          }
          this.time = this.timeItems.find(item => item.title === `${hour}:${minutes}`)?.title || `${minutes < '30' ? hour : +hour + 1 + ''}:${minutes < '30' ? '30' : '00'}`;
        }
      })
    },
  },

  directives: {
    ClickOutside
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.ob-date-picker {
  position: relative;
  height: 52px;
  padding: 7px 11px;
  display: flex;
  border: 1px solid #d1d2d6;
  border-radius: 3px;
  border-radius: 0.25em;

  &--error {
    border-color: $color-error;
  }
}

.ob-date-picker__left {
  display: flex;
  flex-direction: column;
  flex-grow: 1;
}

.ob-date-picker__label {
  @include font-mixin(12px, 16px, 400, $color-grey-label, 0.4);
}

.ob-date-picker__content {
  display: flex;
  align-items: flex-end;
}

.ob-date-picker__input {
  width: auto;
  border: none;
  text-align: center;
  -moz-appearance: textfield;
  font-family: Roboto, sans-serif;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 20px;
  letter-spacing: 0.2px;
  text-align: left;

  &::-webkit-inner-spin-button {
    display: none;
  }

  &:focus {
    outline: none;
  }
}

.ob-date-picker__divider {
  pointer-events: none;
  width: 0.5em;
  text-align: center;
  position: relative;
  top: -2px;
}

.ob-date-picker__right {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.ob-date-picker__icon {
  font-size: 24px;
  color: $color-blue-navy-blue;
  cursor: pointer;

  &:hover {
    opacity: 0.8;
  }
}

.ob-date-picker__calendar-container {
  display: flex;
  width: 100%;
}

.ob-date-picker__calendar {
  position: relative;
  background-color: #fff;
  width: 316px;
}

.ob-date-picker__time {
  display: flex;
  flex-direction: column;
  // justify-content: space-between;
  padding: 16px 20px 20px 0;
  min-width: 180px;
}

.ob-date-picker__time-label {
  @include font-mixin(16px, 20px, 600, $color-text-base, 0.4);  
}

.ob-date-picker__time-select {
  margin-top: 20px;
  height: 100%;
  display: flex;
  flex-direction: column;

  button {
    margin-top: auto;
  }
}

.ob-date-picker__error {
  margin-left: 5px;
  color: $color-error;
}

.date-time-input {
  margin-bottom: 20px;
  position: relative;
  height: 52px;
  padding: 7px 11px;
  border: 1px solid #d1d2d6;
  border-radius: 3px;
  border-radius: 0.25em;
}
</style>
